/* menubar.c generated by valac 0.20.1, the Vala compiler
 * generated from menubar.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 *
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <lightdm.h>


#define TYPE_MENU_BAR (menu_bar_get_type ())
#define MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MENU_BAR, MenuBar))
#define MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MENU_BAR, MenuBarClass))
#define IS_MENU_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MENU_BAR))
#define IS_MENU_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MENU_BAR))
#define MENU_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MENU_BAR, MenuBarClass))

typedef struct _MenuBar MenuBar;
typedef struct _MenuBarClass MenuBarClass;
typedef struct _MenuBarPrivate MenuBarPrivate;

#define TYPE_BACKGROUND (background_get_type ())
#define BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND, Background))
#define BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND, BackgroundClass))
#define IS_BACKGROUND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND))
#define IS_BACKGROUND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND))
#define BACKGROUND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND, BackgroundClass))

typedef struct _Background Background;
typedef struct _BackgroundClass BackgroundClass;

struct _MenuBar {
	GtkMenuBar parent_instance;
	MenuBarPrivate * priv;
};

struct _MenuBarClass {
	GtkMenuBarClass parent_class;
};

struct _MenuBarPrivate {
	gboolean _high_contrast;
};


static gpointer menu_bar_parent_class = NULL;

GType menu_bar_get_type (void) G_GNUC_CONST;
#define MENU_BAR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MENU_BAR, MenuBarPrivate))
enum  {
	MENU_BAR_DUMMY_PROPERTY,
	MENU_BAR_HIGH_CONTRAST
};
#define MENU_BAR_HEIGHT 32
GType background_get_type (void) G_GNUC_CONST;
MenuBar* menu_bar_new (Background* bg, GtkAccelGroup* ag);
MenuBar* menu_bar_construct (GType object_type, Background* bg, GtkAccelGroup* ag);
void menu_bar_set_layouts (MenuBar* self, GList* layouts);
void menu_bar_set_keyboard_state (MenuBar* self);
gboolean menu_bar_get_high_contrast (MenuBar* self);
static void menu_bar_set_high_contrast (MenuBar* self, gboolean value);
static void menu_bar_finalize (GObject* obj);
static void _vala_menu_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_menu_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


MenuBar* menu_bar_construct (GType object_type, Background* bg, GtkAccelGroup* ag) {
	MenuBar * self = NULL;
	g_return_val_if_fail (bg != NULL, NULL);
	g_return_val_if_fail (ag != NULL, NULL);
	self = (MenuBar*) g_object_new (object_type, NULL);
	return self;
}


MenuBar* menu_bar_new (Background* bg, GtkAccelGroup* ag) {
	return menu_bar_construct (TYPE_MENU_BAR, bg, ag);
}


void menu_bar_set_layouts (MenuBar* self, GList* layouts) {
	g_return_if_fail (self != NULL);
}


void menu_bar_set_keyboard_state (MenuBar* self) {
	g_return_if_fail (self != NULL);
}


gboolean menu_bar_get_high_contrast (MenuBar* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_high_contrast;
	result = _tmp0_;
	return result;
}


static void menu_bar_set_high_contrast (MenuBar* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_high_contrast = _tmp0_;
	g_object_notify ((GObject *) self, "high-contrast");
}


static void menu_bar_class_init (MenuBarClass * klass) {
	menu_bar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MenuBarPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_menu_bar_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_menu_bar_set_property;
	G_OBJECT_CLASS (klass)->finalize = menu_bar_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MENU_BAR_HIGH_CONTRAST, g_param_spec_boolean ("high-contrast", "high-contrast", "high-contrast", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void menu_bar_instance_init (MenuBar * self) {
	self->priv = MENU_BAR_GET_PRIVATE (self);
	self->priv->_high_contrast = FALSE;
}


static void menu_bar_finalize (GObject* obj) {
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MENU_BAR, MenuBar);
	G_OBJECT_CLASS (menu_bar_parent_class)->finalize (obj);
}


GType menu_bar_get_type (void) {
	static volatile gsize menu_bar_type_id__volatile = 0;
	if (g_once_init_enter (&menu_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MenuBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) menu_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MenuBar), 0, (GInstanceInitFunc) menu_bar_instance_init, NULL };
		GType menu_bar_type_id;
		menu_bar_type_id = g_type_register_static (GTK_TYPE_MENU_BAR, "MenuBar", &g_define_type_info, 0);
		g_once_init_leave (&menu_bar_type_id__volatile, menu_bar_type_id);
	}
	return menu_bar_type_id__volatile;
}


static void _vala_menu_bar_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
	switch (property_id) {
		case MENU_BAR_HIGH_CONTRAST:
		g_value_set_boolean (value, menu_bar_get_high_contrast (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_menu_bar_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	MenuBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MENU_BAR, MenuBar);
	switch (property_id) {
		case MENU_BAR_HIGH_CONTRAST:
		menu_bar_set_high_contrast (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



